package jp.mosp.common.part;

import java.util.Date;

import jp.mosp.workflow.dao.CtOvertimeRequestDao;
import jp.mosp.workflow.dto.CtOvertimeRequestDto;

/**
 * 残業申請に関するPartクラス
 * @author yoshida
 *	@version	0.0.1
 */
public class OverTimePart extends BasePart {

	/**
	 * コンストラクタ
	 */
	public OverTimePart() {
		super();
	}

	/**
	 * コンストラクタ
	 * @param partInfo
	 */
	public OverTimePart(PartInfo partInfo) {
		super(partInfo);
	}

	/**
	 * 残業申請テーブルDAOの取得
	 * @return	初期化済みCtOvertimeRequestDaoインスタンス
	 * @throws Exception
	 */
	public CtOvertimeRequestDao getCtOvertimeRequestDao() throws Exception {
		return (CtOvertimeRequestDao) getPreparedDao(CtOvertimeRequestDao.class.getCanonicalName());
	}

	/**
	 * 残業申請情報取得
	 * @param voucher		対象伝票番号
	 * @return	残業申請情報DTO
	 * @throws Exception
	 */
	public CtOvertimeRequestDto getOverTimeRequest(int voucher) throws Exception {
		return getCtOvertimeRequestDao().findForKey(voucher);
	}

	/**
	 * 対象年月日残業申請情報取得
	 * @param kCode				対象社員コード
	 * @param targetDate		対象年月日
	 * @return	残業申請情報DTO
	 * @throws Exception
	 */
	public CtOvertimeRequestDto getTargetOverTimeRequest(
			String kCode,
			Date targetDate
	) throws Exception {
		return getCtOvertimeRequestDao().findForWorkDate(
				kCode,
				DatePart.convDateFormattedByHyphen(targetDate)
		);
	}

}
